// USBMotorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "USBMotor.h"
#include "USBMotorDlg.h"
#include <io.h>
#include <direct.h>
#include <dbt.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CUSBMotorDlg dialog
CUSBMotorDlg::CUSBMotorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSBMotorDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSBMotorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_HOME_STATUS, m_HomeStatus);
	DDX_Control(pDX, IDC_MOVE_STATUS, m_MoveStatus);
	DDX_Control(pDX, IDC_SPIN_VELOCITY, m_VelocitySpin);
	DDX_Control(pDX, IDC_COMBO_MAX_COUNTS, m_MaxCountsCombo);
}

BEGIN_MESSAGE_MAP(CUSBMotorDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_JOG, &CUSBMotorDlg::OnBnClickedButtonJogPlus)
	ON_BN_CLICKED(IDC_BUTTON_JOG_MINUS, &CUSBMotorDlg::OnBnClickedButtonJogMinus)
	ON_BN_CLICKED(IDC_MOVE, &CUSBMotorDlg::OnBnClickedMove)
	ON_BN_CLICKED(IDC_HOME, &CUSBMotorDlg::OnBnClickedHome)
	ON_BN_CLICKED(IDC_HALT, &CUSBMotorDlg::OnBnClickedHalt)
	ON_MESSAGE(WM_DEVICECHANGE, &CUSBMotorDlg::Main_OnDeviceChange)
	ON_BN_CLICKED(IDC_SAVE, &CUSBMotorDlg::OnBnClickedSave)
	ON_BN_CLICKED(IDC_BUTTON_SET_VELOCITY, &CUSBMotorDlg::OnBnClickedButtonSetVelocity)
	ON_CBN_EDITCHANGE(IDC_COMBO_MAX_COUNTS, &CUSBMotorDlg::OnCbnEditchangeComboMaxCounts)
	ON_CBN_SELCHANGE(IDC_COMBO_MAX_COUNTS, &CUSBMotorDlg::OnCbnSelchangeComboMaxCounts)
END_MESSAGE_MAP()


// CUSBMotorDlg message handlers

void CUSBMotorDlg::Disconnect()
{
	piDisconnectMotor(pUsb);
	pUsb = NULL;
	SetDlgItemText(IDC_MOTOR_CONNECT,"Disconnected");
}

bool CUSBMotorDlg::CheckVelocity(int Velocity)
{
	if ((Velocity < 1) || (Velocity > m_MaxSpeed))
	{
		CString s;
		s.Format("Velocity must be between 1 and %d!", m_MaxSpeed);
		AfxMessageBox(s);
		if (Velocity < 1)
			Velocity = 1;
		else if (Velocity > m_MaxSpeed)
			Velocity = m_MaxSpeed;
		s.Format("%d", Velocity);
		SetDlgItemText(IDC_EDIT_VELOCITY, s);
		return false;
	}
	return true;
}

BOOL CUSBMotorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_GreenLED = (HBITMAP)LoadImage(AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDB_GREEN_LED), IMAGE_BITMAP, 20, 20, 0L);
	m_RedLED = (HBITMAP)LoadImage(AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDB_RED_LED), IMAGE_BITMAP, 20, 20, 0L);
	m_GreyLED = (HBITMAP)LoadImage(AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDB_GREY_LED), IMAGE_BITMAP, 20, 20, 0L);

	m_HomeStatus.SetBitmap(m_GreyLED);
	m_MoveStatus.SetBitmap(m_GreyLED);

	SetDlgItemText(IDC_STATIC_VELOCITY,"0");
	SetDlgItemText(IDC_STATIC_POSITION,"0");

	// Set range for spin control on velocity edit box.
	m_MaxSpeed = 12;
	m_VelocitySpin.SetRange(1, short(m_MaxSpeed));

	m_MotorStatus = MotorStopped;

	// Set registry key names. These are "global constants".
	m_RegistryKey = "Software\\Picard Industries\\USB Motor";
	m_RegistryNameSerialNumber = "Serial Number 1";
	m_RegistryNameVelocity = "Velocity";
	m_RegistryNameJogDistance = "Jog Distance";
	m_RegistryNamePosition = "Position";
	m_RegistryNameMaxCount = "MaxCount";

	RetrieveSettings();

	// Update the label on the move edit box.
	OnCbnSelchangeComboMaxCounts();

	pUsb = piConnectMotor(&ErrorNumber,Motor1SerialNum);
	if (ErrorNumber == PI_DEVICE_NOT_FOUND)
	{
		Disconnect();
	}
	else if (ErrorNumber == PI_NO_ERROR)
	{
		SetDlgItemText(IDC_MOTOR_CONNECT,"Motor Ready");
	}

	SetTimer(1,150,NULL);  // Timer for polling status
	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// There is no OK button in this dialog app. The only time this
// function gets called is if the user is in an edit box, and hits
// the return key. MFC interprets this as hitting the OK button!
// So we ignore the OnOK call (do not call CDialog::OnOK).
void CUSBMotorDlg::OnOK()
{
}

// Called with the Exit button, or the close button (X in top right corner).
void CUSBMotorDlg::OnCancel()
{
	SaveSettings();

	if (pUsb != NULL)
	{
		Disconnect();
	}
	CDialog::OnCancel();
}


BOOL CUSBMotorDlg::RetrieveSettings(void)
{
	HKEY hKey;
    DWORD dwRet;
    DWORD dwData;
    DWORD dwDataLen = 0;
	CString s;

	// Open the key
	dwRet = RegOpenKeyEx(HKEY_CURRENT_USER, m_RegistryKey,
				    0, KEY_READ, &hKey);

	//Check if the registry exists
	bool KeyOpen = (dwRet == ERROR_SUCCESS);

	Motor1SerialNum = 1;
	if (KeyOpen)
	{
		dwDataLen = sizeof(dwData);
		dwRet = RegQueryValueEx(hKey, m_RegistryNameSerialNumber,
					NULL, NULL, (LPBYTE)&dwData, &dwDataLen);
		if (dwRet == ERROR_SUCCESS && dwDataLen == sizeof(dwData))
			Motor1SerialNum = dwData;
	}
	s.Format("%04d", Motor1SerialNum);
	SetDlgItemText(IDC_SERIALNUM1, s);

	int Velocity = 10;
	if (KeyOpen)
	{
		dwDataLen = sizeof(dwData);
		dwRet = RegQueryValueEx(hKey, m_RegistryNameVelocity,
					NULL, NULL, (LPBYTE)&dwData, &dwDataLen);
		if (dwRet == ERROR_SUCCESS && dwDataLen == sizeof(dwData))
			Velocity = dwData;
	}
	s.Format("%d", Velocity);
	SetDlgItemText(IDC_EDIT_VELOCITY, s);

	int JogDistance = 5;
	if (KeyOpen)
	{
		dwDataLen = sizeof(dwData);
		dwRet = RegQueryValueEx(hKey, m_RegistryNameJogDistance,
					NULL, NULL, (LPBYTE)&dwData, &dwDataLen);
		if (dwRet == ERROR_SUCCESS && dwDataLen == sizeof(dwData))
			JogDistance = dwData;
	}
	s.Format("%d", JogDistance);
	SetDlgItemText(IDC_EDIT_JOG_STEPS, s);

	int Position = 1;
	if (KeyOpen)
	{
		dwDataLen = sizeof(dwData);
		dwRet = RegQueryValueEx(hKey, m_RegistryNamePosition,
					NULL, NULL, (LPBYTE)&dwData, &dwDataLen);
		if (dwRet == ERROR_SUCCESS && dwDataLen == sizeof(dwData))
			Position = dwData;
	}
	s.Format("%d", Position);
	SetDlgItemText(IDC_EDIT_POSITION, s);

	int MaxCount = 1900;
	if (KeyOpen)
	{
		dwDataLen = sizeof(dwData);
		dwRet = RegQueryValueEx(hKey, m_RegistryNameMaxCount,
					NULL, NULL, (LPBYTE)&dwData, &dwDataLen);
		if (dwRet == ERROR_SUCCESS && dwDataLen == sizeof(dwData))
			MaxCount = dwData;
	}

	int i = m_MaxCountsCombo.AddString("1900 (USB-MO)");
	m_MaxCountsCombo.SetItemData(i, 1900);
	i = m_MaxCountsCombo.AddString("5800 (USB-MO-2)");
	m_MaxCountsCombo.SetItemData(i, 5800);
	if (MaxCount != 1900 && MaxCount != 5800)
	{
		s.Format("%d", MaxCount);
		i = m_MaxCountsCombo.AddString(s);
		m_MaxCountsCombo.SetItemData(i, MaxCount);
	}
	// Select the proper one
	// The index's may have changed, because sort property is true.
	// So find the correct one to select
	int sel = 0;
	for (int i=0; i<m_MaxCountsCombo.GetCount(); i++)
	{
		if (int(m_MaxCountsCombo.GetItemData(i)) == MaxCount)
		{
			sel = i;
			break;
		}
	}
	m_MaxCountsCombo.SetCurSel(sel);

	if (KeyOpen)
	{
		RegCloseKey(hKey);
	}

	return TRUE;

}

BOOL CUSBMotorDlg::SaveSettings(void)
{
	HKEY hKey;
    DWORD dwRet;
    DWORD dwData;
	CString s;
	BOOL ReturnValue = TRUE;

	// Open the key, or create it if it does not exist
	dwRet = RegCreateKeyEx(HKEY_CURRENT_USER, m_RegistryKey, 0,
				NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
				NULL, &hKey, NULL);
	if (dwRet != ERROR_SUCCESS)
	{
		AfxMessageBox( "Unable to create registry key to save settings.",MB_OK|MB_ICONSTOP );
		return FALSE;
	}

	GetDlgItemText(IDC_SERIALNUM1, s);
	Motor1SerialNum = atoi(s);
	dwData = Motor1SerialNum;
    dwRet = RegSetValueEx(hKey, m_RegistryNameSerialNumber, 0,
				REG_DWORD, (LPBYTE)(&dwData), sizeof(dwData));
	if (dwRet != ERROR_SUCCESS)
	{
		AfxMessageBox( "Unable to save serial number to registry.",MB_OK|MB_ICONSTOP );
		ReturnValue = FALSE;
	}

	GetDlgItemText(IDC_EDIT_VELOCITY, s);
	dwData = atoi(s);
    dwRet = RegSetValueEx(hKey, m_RegistryNameVelocity, 0,
				REG_DWORD, (LPBYTE)(&dwData), sizeof(dwData));
	if (dwRet != ERROR_SUCCESS)
	{
		AfxMessageBox( "Unable to save velocity to registry.",MB_OK|MB_ICONSTOP );
		ReturnValue = FALSE;
	}

	GetDlgItemText(IDC_EDIT_JOG_STEPS, s);
	dwData = atoi(s);
    dwRet = RegSetValueEx(hKey, m_RegistryNameJogDistance, 0,
				REG_DWORD, (LPBYTE)(&dwData), sizeof(dwData));
	if (dwRet != ERROR_SUCCESS)
	{
		AfxMessageBox( "Unable to save jog distance to registry.",MB_OK|MB_ICONSTOP );
		ReturnValue = FALSE;
	}

	GetDlgItemText(IDC_EDIT_POSITION, s);
	dwData = atoi(s);
    dwRet = RegSetValueEx(hKey, m_RegistryNamePosition, 0,
				REG_DWORD, (LPBYTE)(&dwData), sizeof(dwData));
	if (dwRet != ERROR_SUCCESS)
	{
		AfxMessageBox( "Unable to save position to registry.",MB_OK|MB_ICONSTOP );
		ReturnValue = FALSE;
	}

	GetDlgItemText(IDC_COMBO_MAX_COUNTS, s);
	dwData = atoi(s);
    dwRet = RegSetValueEx(hKey, m_RegistryNameMaxCount, 0,
				REG_DWORD, (LPBYTE)(&dwData), sizeof(dwData));
	if (dwRet != ERROR_SUCCESS)
	{
		AfxMessageBox( "Unable to save motor length to registry.",MB_OK|MB_ICONSTOP );
		ReturnValue = FALSE;
	}

	RegCloseKey(hKey);

	return ReturnValue;
}

void CUSBMotorDlg::OnBnClickedSave()
{
	int SerialNum1; // Save local value until new ones are checked for validity

	CString SerialNumStr;

	KillTimer(1);

	GetDlgItemText(IDC_SERIALNUM1, SerialNumStr);
	SerialNum1 = atoi(SerialNumStr);
	Motor1SerialNum = SerialNum1;

	SaveSettings();

	if (pUsb != NULL)  // Close all open devices
	{
		Disconnect();
	}

	pUsb = piConnectMotor(&ErrorNumber,Motor1SerialNum);
	if (ErrorNumber == PI_DEVICE_NOT_FOUND)
	{
		Disconnect();
	}
	else if (ErrorNumber == PI_NO_ERROR)
	{
		SetDlgItemText(IDC_MOTOR_CONNECT,"Motor Ready");
	}

	SetTimer(1,150,NULL);  // Timer for polling input report
	
}

LRESULT CUSBMotorDlg::Main_OnDeviceChange(WPARAM wParam, LPARAM lParam)
{
	UNUSED_ALWAYS(wParam);
	UNUSED_ALWAYS(lParam);

	CString VelocityStr;
	int MotorPosition;

	if (pUsb == NULL)  // never connected
	{
		pUsb = piConnectMotor(&ErrorNumber,Motor1SerialNum);
		if (ErrorNumber == PI_DEVICE_NOT_FOUND)
		{
			Disconnect();
		}
		else if (ErrorNumber == PI_NO_ERROR)
		{
			SetDlgItemText(IDC_MOTOR_CONNECT,"Motor Ready");
		}
	}
	else
	{
		ErrorNumber = piGetMotorPosition(&MotorPosition,pUsb);
		if (ErrorNumber == PI_DEVICE_NOT_FOUND)
		{
			Disconnect();
		}
		else if (ErrorNumber == PI_NO_ERROR)
		{
			SetDlgItemText(IDC_MOTOR_CONNECT,"Motor Ready");
		}
	}
		return TRUE;
}
void CUSBMotorDlg::OnTimer(UINT_PTR nIDEvent)
{
	UpdateStatus();

	CDialog::OnTimer(nIDEvent);
}

void CUSBMotorDlg::UpdateStatus()
{
	CString Status;
	int Velocity = 0;
	int Position = 0;
	BOOL AtHome;
	BOOL Moving;

	if (pUsb == NULL)  // never connected
		return;
	else
	{
		ErrorNumber = piGetMotorHomeStatus(&AtHome, pUsb);
		if (ErrorNumber == PI_DEVICE_NOT_FOUND)
		{
			Disconnect();
			return;
		}
		else
		{
			if (AtHome)
				m_HomeStatus.SetBitmap(m_RedLED);
			else
				m_HomeStatus.SetBitmap(m_GreyLED);
		}

		ErrorNumber = piGetMotorMovingStatus(&Moving, pUsb);
		if (ErrorNumber == PI_DEVICE_NOT_FOUND)
		{
			Disconnect();
			return;
		}
		if (m_MotorStatus == MotorStarted && !Moving)
		{
			// User clicked a button that started motor moving.
			// We see motor stopped. This can happen because
			// a) Windows buffers the status bytes back from the
			//    device, and so the motor has started to move but
			//    we don't see it reflected in the moving bit
			//    yet. Or,
			// b) the move was a short distance and it's over already.
			// To check for this, we read the moving status two
			// more times. If it's still not moving after those
			// two reads, we assumb case (b).
			ErrorNumber = piGetMotorMovingStatus(&Moving, pUsb);
			if (ErrorNumber == PI_DEVICE_NOT_FOUND)
			{
				Disconnect();
				return;
			}
			if (!Moving)
			{
				ErrorNumber = piGetMotorMovingStatus(&Moving, pUsb);
				if (ErrorNumber == PI_DEVICE_NOT_FOUND)
				{
					Disconnect();
					return;
				}
			}
			
		}
		if (Moving)
		{
			m_MoveStatus.SetBitmap(m_RedLED);
			if (m_MotorStatus == MotorStopped)
			{
				// This shouldn't be able to happen
				TRACE("Motor moving but not started.\n");
				m_MotorStatus = MotorMoving;
			}
			else if (m_MotorStatus == MotorStarted)
			{
				m_MotorStatus = MotorMoving;
			}
		}
		else
		{
			if (m_MotorStatus != MotorStopped)
			{
				m_MoveStatus.SetBitmap(m_GreyLED);
				m_MotorStatus = MotorStopped;
			}
		}

		ErrorNumber = piGetMotorVelocity(&Velocity, pUsb);
		if (ErrorNumber == PI_DEVICE_NOT_FOUND)
		{
			Disconnect();
			return;
		}
		else
		{
			Status.Format("%d",Velocity);
			SetDlgItemText(IDC_STATIC_VELOCITY,Status);
		}

		ErrorNumber = piGetMotorPosition(&Position, pUsb);
		if (ErrorNumber == PI_DEVICE_NOT_FOUND)
		{
			Disconnect();
			return;
		}
		else
		{
			Status.Format("%d",Position);
			SetDlgItemText(IDC_STATIC_POSITION,Status);
		}

	}
}

void CUSBMotorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUSBMotorDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUSBMotorDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

int CUSBMotorDlg::GetMaxCounts()
{
	CString s;
	m_MaxCountsCombo.GetWindowText(s);
	return GetMaxCounts(s);
}

int CUSBMotorDlg::GetMaxCounts(const CString& s)
{
	int max = atol(s);
	if (max < 1)
		max = 1;
	if (max > 32767)
		max = 32767;
	return max;
}

void CUSBMotorDlg::LimitPosition(int& Position)
{
	if (Position < 1)
		Position = 1;
	int MaxCounts = GetMaxCounts();
	if (Position > MaxCounts)
		Position = MaxCounts;
}

void CUSBMotorDlg::OnBnClickedButtonJogPlus()
{
	int Velocity;
	int Position;
	int StepSize;

	CString VarStr;
	if (m_MotorStatus != MotorStopped)
	{
		return;
	}

	GetDlgItemText(IDC_EDIT_VELOCITY,VarStr);
	Velocity = atoi(VarStr.GetBuffer());

	GetDlgItemText(IDC_STATIC_POSITION,VarStr);
	Position = atoi(VarStr.GetBuffer());

	GetDlgItemText(IDC_EDIT_JOG_STEPS,VarStr);
	StepSize = atoi(VarStr.GetBuffer());

	Position += StepSize;

	if (!CheckVelocity(Velocity))
		return;

	LimitPosition(Position);

	if (pUsb == NULL)  // never connected
		return;
	else
	{
		SaveSettings();
		ErrorNumber = piRunMotorToPosition(Position, Velocity, pUsb);
		if (ErrorNumber == PI_DEVICE_NOT_FOUND)
		{
			Disconnect();
			return;
		}
		else
		{
			m_MotorStatus = MotorStarted;
		}
	}
}
void CUSBMotorDlg::OnBnClickedButtonJogMinus()
{
	int Velocity;
	int Position;
	int StepSize;

	CString VarStr;
	if (m_MotorStatus != MotorStopped)
	{
		return;
	}

	GetDlgItemText(IDC_EDIT_VELOCITY,VarStr);
	Velocity = atoi(VarStr.GetBuffer());

	GetDlgItemText(IDC_STATIC_POSITION,VarStr);
	Position = atoi(VarStr.GetBuffer());

	GetDlgItemText(IDC_EDIT_JOG_STEPS,VarStr);
	StepSize = atoi(VarStr.GetBuffer());

	Position -= StepSize;
	LimitPosition(Position);

	if (!CheckVelocity(Velocity))
		return;

	if (pUsb == NULL)  // never connected
		return;
	else
	{
		SaveSettings();
		ErrorNumber = piRunMotorToPosition(Position, Velocity, pUsb);
		if (ErrorNumber == PI_DEVICE_NOT_FOUND)
		{
			Disconnect();
			return;
		}
		else
		{
			m_MotorStatus = MotorStarted;
		}
	}
}

void CUSBMotorDlg::OnBnClickedMove()
{
	int Velocity;
	int Position;
	CString VelocityStr;
	CString PositionStr;

	if (m_MotorStatus != MotorStopped)
	{
		return;
	}
	if (pUsb == NULL)  // never connected
		return;
	else
	{

		GetDlgItemText(IDC_EDIT_VELOCITY,VelocityStr);
		Velocity = atoi(VelocityStr.GetBuffer());

		if (!CheckVelocity(Velocity))
			return;

		GetDlgItemText(IDC_EDIT_POSITION,PositionStr);
		Position = atoi(PositionStr.GetBuffer());
		LimitPosition(Position);

		SaveSettings();
		ErrorNumber = piRunMotorToPosition(Position, Velocity, pUsb);
		if (ErrorNumber == PI_DEVICE_NOT_FOUND)
		{
			Disconnect();
			return;
		}
		else
		{
			m_MotorStatus = MotorStarted;
		}
	}
}

void CUSBMotorDlg::OnBnClickedHome()
{
	int Velocity;
	CString VelocityStr;

	if (m_MotorStatus != MotorStopped)
	{
		return;
	}
	if (pUsb == NULL)  // never connected
		return;
	else
	{
		GetDlgItemText(IDC_EDIT_VELOCITY,VelocityStr);
		Velocity = atoi(VelocityStr.GetBuffer());

		if (!CheckVelocity(Velocity))
			return;

		ErrorNumber = piHomeMotor(Velocity, pUsb);
		if (ErrorNumber == PI_DEVICE_NOT_FOUND)
		{
			Disconnect();
			return;
		}
		// Home does not set m_MotorStatus because the Moving bit from
        // the device does not turn on during home.
	}
}

void CUSBMotorDlg::OnBnClickedHalt()
{
	CString VelocityStr;

	if (pUsb == NULL)  // never connected
		return;
	else
	{
		ErrorNumber = piHaltMotor(pUsb);
		if (ErrorNumber == PI_DEVICE_NOT_FOUND)
		{
			Disconnect();
		}
	}
}

void CUSBMotorDlg::OnBnClickedButtonSetVelocity()
{
	int Velocity;
	CString VelocityStr;
	CString PositionStr;

	if (m_MotorStatus != MotorStopped)
	{
		return;
	}

	if (pUsb == NULL)  // never connected
		return;
	else
	{
		GetDlgItemText(IDC_EDIT_VELOCITY,VelocityStr);
		Velocity = atoi(VelocityStr.GetBuffer());

		if (!CheckVelocity(Velocity))
			return;

		SaveSettings();
		ErrorNumber = piSetMotorVelocity(Velocity, pUsb);
		if (ErrorNumber == PI_DEVICE_NOT_FOUND)
		{
			Disconnect();
			return;
		}
	}
}

void CUSBMotorDlg::OnCbnEditchangeComboMaxCounts()
{
	int max = GetMaxCounts();
	CString s;
	s.Format("(1-%d)", max);
	SetDlgItemText(IDC_STATIC_POSITION_LIMITS, s);
	SaveSettings();
}

void CUSBMotorDlg::OnCbnSelchangeComboMaxCounts()
{
	// You can't just call OnCbnEditchangeComboMaxCounts(), because
	// the window text hasn't been updated yet.
	int i = m_MaxCountsCombo.GetCurSel();
	if (i<0)
		i=0;
	CString s;
	m_MaxCountsCombo.GetLBText(i, s);
	int max = GetMaxCounts(s);
	s.Format("(1-%d)", max);
	SetDlgItemText(IDC_STATIC_POSITION_LIMITS, s);
	SaveSettings();
}
